package com.example.linyingqi.softapdemo;

import android.content.Context;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.gizwits.gizwifisdk.api.GizWifiDevice;
import com.gizwits.gizwifisdk.api.GizWifiSDK;
import com.gizwits.gizwifisdk.enumration.GizEventType;
import com.gizwits.gizwifisdk.enumration.GizWifiErrorCode;
import com.gizwits.gizwifisdk.listener.GizWifiSDKListener;

import java.util.List;

public class MainActivity extends AppCompatActivity {

    ListView lv_lan_devices;
    LanDeviceAdapter lanDeviceAdapter ;

    GizWifiSDKListener gizWifiSDKListener = new GizWifiSDKListener() {
        @Override
        public void didNotifyEvent(GizEventType eventType, Object eventSource, GizWifiErrorCode eventID, String eventMessage) {
            super.didNotifyEvent(eventType, eventSource, eventID, eventMessage);
            if(eventID== GizWifiErrorCode.GIZ_SDK_SUCCESS)
            {

            }
        }

        @Override
        public void didDiscovered(GizWifiErrorCode result, List<GizWifiDevice> deviceList) {
            super.didDiscovered(result, deviceList);
            List<GizWifiDevice> gizWifiDevices = GizWifiSDK.sharedInstance().getDeviceList();
            lanDeviceAdapter = new LanDeviceAdapter(gizWifiDevices,MainActivity.this);
            lv_lan_devices.setAdapter(lanDeviceAdapter);

        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        lv_lan_devices=(ListView)findViewById(R.id.lan_device_lv);
        GizWifiSDK.sharedInstance().startWithAppID(this,"35ae9ec5dcea47e9ae3d47d746738e05",null,null,true);
        findViewById(R.id.config_tv).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                startActivity(new Intent(MainActivity.this,SoftApConfigActivity.class));
            }
        });
    }



    class LanDeviceAdapter extends BaseAdapter{
        List<GizWifiDevice> gizWifiDeviceList;
        Context context;

        public LanDeviceAdapter(List<GizWifiDevice> gizWifiDeviceList, Context context) {
            this.gizWifiDeviceList = gizWifiDeviceList;
            this.context = context;
        }

        @Override
        public int getCount() {
            return gizWifiDeviceList.size();
        }

        @Override
        public Object getItem(int position) {
            return null;
        }

        @Override
        public long getItemId(int position) {
            return 0;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            View view = LayoutInflater.from(context).inflate(R.layout.item_devices,null);
            ((TextView)view.findViewById(R.id.device_name_tv)).setText(gizWifiDeviceList.get(position).getProductName());
            ((TextView)view.findViewById(R.id.device_mac_tv)).setText(gizWifiDeviceList.get(position).getMacAddress());
            return view;
        }
    }


    @Override
    protected void onResume() {
        super.onResume();
        GizWifiSDK.sharedInstance().setListener(gizWifiSDKListener);

    }
}
