package com.example.linyingqi.softapdemo;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.res.AssetManager;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiConfiguration;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.support.annotation.Nullable;
import android.support.annotation.RequiresApi;
import android.util.Log;
import android.view.View;
import android.webkit.JsResult;
import android.webkit.ValueCallback;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.gizwits.gizwifisdk.api.GizWifiDevice;
import com.gizwits.gizwifisdk.api.GizWifiSDK;
import com.gizwits.gizwifisdk.enumration.GizWifiConfigureMode;
import com.gizwits.gizwifisdk.enumration.GizWifiErrorCode;
import com.gizwits.gizwifisdk.enumration.GizWifiGAgentType;
import com.gizwits.gizwifisdk.listener.GizWifiSDKListener;

import org.json.JSONException;
import org.json.JSONObject;
import org.mozilla.javascript.Function;
import org.mozilla.javascript.NativeJavaObject;
import org.mozilla.javascript.NativeObject;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.ScriptableObject;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.List;

public class SoftApConfigActivity extends Activity {
    Button btn_type, btn_mode, btn_start_config;
    EditText et_wifi_ssid, et_wifi_pwd;
    String softApSsid;
    GizWifiGAgentType[] gizWifiGAgentTypes = new GizWifiGAgentType[]{
            GizWifiGAgentType.GizGAgentAtmelEE,//AtmelEE
            GizWifiGAgentType.GizGAgentMXCHIP,//庆科
            GizWifiGAgentType.GizGAgentHF,//汉枫
            GizWifiGAgentType.GizGAgentRTK,//瑞昱
            GizWifiGAgentType.GizGAgentWM,//联盛德
            GizWifiGAgentType.GizGAgentESP,//乐鑫
            GizWifiGAgentType.GizGAgentQCA,//高通
            GizWifiGAgentType.GizGAgentTI,//TI
            GizWifiGAgentType.GizGAgentFSK,//宇音天下
            GizWifiGAgentType.GizGAgentMXCHIP3,//庆科V3
            GizWifiGAgentType.GizGAgentBL,//古北
            GizWifiGAgentType.GizGAgentFlyLink,//FlyLink
            GizWifiGAgentType.GizGAgentMxchipAWS,//庆科AWS
            GizWifiGAgentType.GizGAgentOther,//其他

    };

    GizWifiConfigureMode[] gizWifiConfigureModes = new GizWifiConfigureMode[]{
            GizWifiConfigureMode.GizWifiAirLink,
            GizWifiConfigureMode.GizWifiSoftAP
    };

    GizWifiConfigureMode gizWifiConfigureMode = GizWifiConfigureMode.GizWifiSoftAP;
    GizWifiGAgentType gizWifiGAgentType=GizWifiGAgentType.GizGAgentESP;

    int progress = 0;

    int scanCount = 0;

    WifiStateReceiver wifiStateReceiver;

    ProgressDialog progressDialog;

    boolean isSoftAPRunning;

    GizWifiSDKListener gizWifiSDKListener = new GizWifiSDKListener() {
        @Override
        public void didSetDeviceOnboarding(GizWifiErrorCode result, GizWifiDevice device) {
            super.didSetDeviceOnboarding(result, device);
            if (result == GizWifiErrorCode.GIZ_SDK_SUCCESS) {
                progressDialog.dismiss();
                Toast.makeText(SoftApConfigActivity.this, "配网成功:" + "\nmac:" + device.getMacAddress() + "\nproductName:" + device.getProductName(), Toast.LENGTH_LONG).show();
            } else if(result!=GizWifiErrorCode.GIZ_SDK_ONBOARDING_STOPPED){
                progressDialog.dismiss();
                Toast.makeText(SoftApConfigActivity.this, "配网失败:"+result.name(),Toast.LENGTH_LONG).show();
            }
        }
    };

    @RequiresApi(api = Build.VERSION_CODES.KITKAT)
    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_soft_ap_config);
        et_wifi_ssid = (EditText) findViewById(R.id.ssid_et);
        et_wifi_pwd = (EditText) findViewById(R.id.pwd_et);
        btn_mode = (Button) findViewById(R.id.config_mode_btn);
        btn_type = (Button) findViewById(R.id.config_type_btn);
        btn_start_config = (Button) findViewById(R.id.start_config_btn);
        findViewById(R.id.back_tv).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        btn_type.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                showTypeDialog();
            }
        });

        btn_mode.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                showModeDialog();
            }
        });

        btn_start_config.setOnClickListener(new View.OnClickListener() {
            @RequiresApi(api = Build.VERSION_CODES.KITKAT)
            @Override
            public void onClick(View v) {
                String ssid = et_wifi_ssid.getText().toString().trim();
                String pwd = et_wifi_pwd.getText().toString().trim();
                if(ssid.equals(""))
                {
                    Toast.makeText(SoftApConfigActivity.this,"请输入WifiSSID",Toast.LENGTH_SHORT).show();
                    return;
                }

                List<GizWifiGAgentType> gizWifiGAgentTypeList = new ArrayList<>();
                gizWifiGAgentTypeList.add(gizWifiGAgentType);
                showProgressDialog();
                if (gizWifiConfigureMode == GizWifiConfigureMode.GizWifiSoftAP) {

                    isSoftAPRunning=false;
                    connectSoftAP();
                } else {
                    GizWifiSDK.sharedInstance().setDeviceOnboarding(ssid, pwd, gizWifiConfigureMode, "xpg", 60, gizWifiGAgentTypeList);
                }
            }
        });

        IntentFilter filter = new IntentFilter();
        filter.addAction(WifiManager.WIFI_STATE_CHANGED_ACTION);
        filter.addAction(WifiManager.NETWORK_STATE_CHANGED_ACTION);
        wifiStateReceiver = new WifiStateReceiver();
        registerReceiver(wifiStateReceiver, filter);
        GizWifiSDK.sharedInstance().setListener(gizWifiSDKListener);


        String filePath = Environment.getExternalStorageDirectory()+"/GizWifiSDK/com.gizwits.xb/GizSDKLog/Client/GizSDKClientLogFile.sys";

        String str = "";
        Log.e("log",filePath);
        try{
            FileInputStream fin = new FileInputStream(filePath);
            int length = fin.available();
            byte[] buffer = new byte[length];
            fin.read(buffer);
            str = new String(buffer);
            fin.close();
            Log.e("log",str);

        }catch (Exception e){
            Log.e("log",e.getMessage());

        }
    }

    /**
     * 执行JS
     *
     * @param js js代码
     * @param functionName js方法名称
     * @param functionParams js方法参数
     * @return
     */
    public String runScript(String js, String functionName, Object[] functionParams) {
        org.mozilla.javascript.Context rhino = org.mozilla.javascript.Context.enter();
        rhino.setOptimizationLevel(-1);
        try {
            Scriptable scope = rhino.initStandardObjects();
            rhino.setLanguageVersion(org.mozilla.javascript.Context.VERSION_ES6);

            ScriptableObject.putProperty(scope, "javaContext", org.mozilla.javascript.Context.javaToJS(SoftApConfigActivity.this, scope));
            ScriptableObject.putProperty(scope, "javaLoader", org.mozilla.javascript.Context.javaToJS(SoftApConfigActivity.class.getClassLoader(), scope));

            rhino.evaluateString(scope, js, "MainActivity", 1, null);

            Function function = (Function) scope.get(functionName, scope);

            Object result = function.call(rhino, scope, scope, functionParams);
            if (result instanceof String) {
                return (String) result;
            } else if (result instanceof NativeJavaObject) {
                return (String) ((NativeJavaObject) result).getDefaultValue(String.class);
            } else if (result instanceof NativeObject) {
                return (String) ((NativeObject) result).getDefaultValue(String.class);
            }
            return result.toString();//(String) function.call(rhino, scope, scope, functionParams);
        } finally {
            org.mozilla.javascript.Context.exit();
        }
    }

    @Override
    protected void onResume() {
        super.onResume();
        @SuppressLint("WifiManagerLeak") WifiManager wifiManager = (WifiManager)getSystemService(Context.WIFI_SERVICE);
        WifiInfo info = wifiManager.getConnectionInfo();
        String ssid = info.getSSID().replace("\"", "");
        et_wifi_ssid.setText(ssid);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        unregisterReceiver(wifiStateReceiver);
    }

    public void showTypeDialog() {
        final String[] items = {"AtmelEE", "庆科", "汉枫", "瑞昱","联盛德","乐鑫","高通","TI","宇音天下","庆科V3","古北","FlyLink","庆科AWS","其他"};
        AlertDialog.Builder listDialog =
                new AlertDialog.Builder(this);
        listDialog.setTitle("请选择模组类型");
        listDialog.setItems(items, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                // which 下标从0开始
                // ...To-do
                gizWifiGAgentType = gizWifiGAgentTypes[which];
                btn_type.setText("模组类型:" + items[which]);
            }
        });
        listDialog.show();
    }

    public void showModeDialog() {
        final String[] items = {"SoftAp", "AirLink"};
        AlertDialog.Builder listDialog =
                new AlertDialog.Builder(this);
        listDialog.setTitle("请选择配网模式");
        listDialog.setItems(items, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                // which 下标从0开始
                // ...To-do
                btn_mode.setText("配网模式:" + items[which]);
                gizWifiConfigureMode = gizWifiConfigureModes[which];

            }
        });
        listDialog.show();
    }

    private void showListDialog(final List<String> softAp) {

        final String[] items = new String[softAp.size()];
        for(int i=0;i<softAp.size();i++)
        {
            items[i]=softAp.get(i).split("###")[0];
        }
        final AlertDialog.Builder listDialog =
                new AlertDialog.Builder(this);
        listDialog.setTitle("搜索到的设备热点");
        listDialog.setItems(items, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                // which 下标从0开始
                // ...To-do
                @SuppressLint("WifiManagerLeak") WifiManager manager = (WifiManager) getSystemService(Context.WIFI_SERVICE);
                String ssid = softAp.get(which).split("###")[0];
                int type = Integer.valueOf(softAp.get(which).split("###")[1]);
                softApSsid = ssid;
                WifiConfiguration wifiConfiguration = configWifiInfo(manager, ssid, type);
                int netId = manager.addNetwork(wifiConfiguration);
                boolean b = manager.enableNetwork(netId, true);
                Log.e("softAp", "连接wifi:" +softApSsid +" "+ netId + " " + b + " " + manager.pingSupplicant());
            }
        });
        listDialog.show();
    }


    private void showProgressDialog() {
        /* @setProgress 设置初始进度
         * @setProgressStyle 设置样式（水平进度条）
         * @setMax 设置进度最大值
         */
        final int MAX_PROGRESS = 60;
        progressDialog = new ProgressDialog(this);
        progressDialog.setProgress(0);
        progressDialog.setTitle("请耐心等待，60S超时");
        progressDialog.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
        progressDialog.setMax(MAX_PROGRESS);
        progressDialog.show();
        /* 模拟进度增加的过程
         * 新开一个线程，每个100ms，进度增加1
         */
        progress = 0;
        new Thread(new Runnable() {
            @Override
            public void run() {
                while (progress < MAX_PROGRESS) {
                    try {
                        Thread.sleep(1000);
                        progress++;
                        progressDialog.setProgress(progress);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
                // 进度达到最大值后，窗口消失
                progressDialog.cancel();
            }
        }).start();

        progressDialog.setOnDismissListener(new DialogInterface.OnDismissListener() {
            @Override
            public void onDismiss(DialogInterface dialog) {
                progress = 61;
                GizWifiSDK.sharedInstance().stopDeviceOnboarding();
            }
        });
    }


    public void connectSoftAP() {
        if (!progressDialog.isShowing()) {
            return;
        }

        @SuppressLint("WifiManagerLeak") WifiManager manager = (WifiManager) getSystemService(Context.WIFI_SERVICE);
        WifiInfo info = manager.getConnectionInfo();
        String connectssid = info.getSSID().replace("\"", "");
        if(connectssid.startsWith("XPG"))
        {
            String config_ssid = et_wifi_ssid.getText().toString().trim();
            String pwd = et_wifi_pwd.getText().toString().trim();
            String softAp = "XPG";
            List<GizWifiGAgentType> gizWifiGAgentTypeList = new ArrayList<>();
            gizWifiGAgentTypeList.add(gizWifiGAgentType);
            GizWifiSDK.sharedInstance().setDeviceOnboarding(config_ssid, pwd, gizWifiConfigureMode, softAp, 60, gizWifiGAgentTypeList);
            return;
        }
        manager.startScan();
        boolean isFoundSoftAp = false;
        List<ScanResult> listb = manager.getScanResults();
        List<String> wifiSSID = new ArrayList<>();
        for (int i = 0; i < listb.size(); i++) {
            Log.e("wifi","BSSID:"+listb.get(i).BSSID+" SSID:"+listb.get(i).SSID);
            String ssid = listb.get(i).SSID.replace("\"", "");
            if (ssid.startsWith("xpg")) {
                wifiSSID.add(ssid+"###"+getType(listb.get(i)));
                isFoundSoftAp = true;
            }
        }
        if(wifiSSID.size()>1)
        {
            showListDialog(wifiSSID);
            return;
        }
        if(isFoundSoftAp){
            String ssid = wifiSSID.get(0).split("###")[0];
            int type = Integer.valueOf(wifiSSID.get(0).split("###")[1]);
            softApSsid = ssid;
            WifiConfiguration wifiConfiguration = configWifiInfo(manager, ssid, type);
            int netId = manager.addNetwork(wifiConfiguration);
            boolean b = manager.enableNetwork(netId, true);
            Log.e("softAp", "连接wifi:" +softApSsid +" "+ netId + " " + b + " " + manager.pingSupplicant());
        }
        if (!isFoundSoftAp&&scanCount<10) {
            scanCount++;
            new Handler().postDelayed(new Runnable() {
                @Override
                public void run() {
                    connectSoftAP();
                }
            },1000);
        }else if(scanCount>=10){
            Toast.makeText(SoftApConfigActivity.this,"找不到该热点前缀",Toast.LENGTH_SHORT).show();
            progressDialog.dismiss();
        }
    }



    public WifiConfiguration configWifiInfo(WifiManager mWifiManager, String SSID, int type) {
        WifiConfiguration config = null;
        if (mWifiManager != null) {
            List<WifiConfiguration> existingConfigs = mWifiManager.getConfiguredNetworks();
            for (WifiConfiguration existingConfig : existingConfigs) {
                if (existingConfig == null) continue;
                if (existingConfig.SSID.equals("\"" + SSID + "\"")  /*&&  existingConfig.preSharedKey.equals("\""  +  password  +  "\"")*/) {
                    config = existingConfig;
                    break;
                }
            }
        }
        if (config == null) {
            config = new WifiConfiguration();
        }
        String softApPassword = "123456789";
        config.allowedAuthAlgorithms.clear();
        config.allowedGroupCiphers.clear();
        config.allowedKeyManagement.clear();
        config.allowedPairwiseCiphers.clear();
        config.allowedProtocols.clear();
        config.SSID = "\"" + SSID + "\"";
        // 分为三种情况：0没有密码1用wep加密2用wpa加密
        if (type == 0) {// WIFICIPHER_NOPASSwifiCong.hiddenSSID = false;
            config.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.NONE);
        } else if (type == 1) {  //  WIFICIPHER_WEP
            config.hiddenSSID = true;
            config.wepKeys[0] = "\"" + softApPassword + "\"";
            config.allowedAuthAlgorithms
                    .set(WifiConfiguration.AuthAlgorithm.SHARED);
            config.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.CCMP);
            config.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.TKIP);
            config.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.WEP40);
            config.allowedGroupCiphers
                    .set(WifiConfiguration.GroupCipher.WEP104);
            config.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.NONE);
            config.wepTxKeyIndex = 0;
        } else if (type == 2) {   // WIFICIPHER_WPA
            config.preSharedKey = "\"" + softApPassword + "\"";
            config.hiddenSSID = true;
            config.allowedAuthAlgorithms
                    .set(WifiConfiguration.AuthAlgorithm.OPEN);
            config.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.TKIP);
            config.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.WPA_PSK);
            config.allowedPairwiseCiphers
                    .set(WifiConfiguration.PairwiseCipher.TKIP);
            config.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.CCMP);
            config.allowedPairwiseCiphers
                    .set(WifiConfiguration.PairwiseCipher.CCMP);
            config.status = WifiConfiguration.Status.ENABLED;
        }
        return config;
    }

    private int getType(ScanResult scanResult) {
        int type = 0;
        if (scanResult.capabilities.contains("WPA"))
            type = 2;
        else if (scanResult.capabilities.contains("WEP"))
            type = 1;
        else
            type = 0;
        return type;
    }

    class WifiStateReceiver extends BroadcastReceiver {

        @Override
        public void onReceive(Context context, Intent intent) {
            // TODO Auto-generated method stub
            if(progressDialog==null||!progressDialog.isShowing())
            {
                return;
            }
            Bundle bundle = intent.getExtras();
            WifiManager wifiManager = (WifiManager) context.getSystemService(Context.WIFI_SERVICE);
            WifiInfo info = wifiManager.getConnectionInfo();
            String ssid = info.getSSID().replace("\"", "");
            Log.e("ssid",ssid);
            if (ssid.equals(softApSsid)&&!isSoftAPRunning) {
                isSoftAPRunning=true;
                String config_ssid = et_wifi_ssid.getText().toString().trim();
                String pwd = et_wifi_pwd.getText().toString().trim();
                String softAp = "xpg";
                List<GizWifiGAgentType> gizWifiGAgentTypeList = new ArrayList<>();
                gizWifiGAgentTypeList.add(gizWifiGAgentType);
                GizWifiSDK.sharedInstance().setDeviceOnboarding(config_ssid, pwd, gizWifiConfigureMode, softAp, 60, gizWifiGAgentTypeList);
            }
        }
    }



}
