package com.example.softapdemo;

import android.net.ConnectivityManager;
import android.net.Network;
import android.net.NetworkCapabilities;
import android.net.NetworkRequest;
import android.os.Build;
import android.os.Bundle;
import android.app.Activity;
import android.content.Context;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Toast;

public class MainActivity extends Activity {
	ConnectivityManager connectivityManager;
    NetworkRequest.Builder builder;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
		connectivityManager = (ConnectivityManager)getSystemService(Context.CONNECTIVITY_SERVICE);
        findViewById(R.id.send_btn).setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				SoftApConfig.getInstance().startConfig(MainActivity.this,"Gizwits", "giz$2025");
			}
		});
        findViewById(R.id.stop_btn).setOnClickListener(new OnClickListener() {
     			@Override
     			public void onClick(View arg0) {
     				SoftApConfig.getInstance().stopConfig();
     			}
     		});
        
        findViewById(R.id.change_4g_btn).setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				 if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
					 try{
			            builder = new NetworkRequest.Builder();
			            builder.addCapability(NetworkCapabilities.NET_CAPABILITY_INTERNET);
			            builder.addTransportType(NetworkCapabilities.TRANSPORT_CELLULAR);
			            connectivityManager.requestNetwork(builder.build(), new ConnectivityManager.NetworkCallback() {
			                @Override
			                public void onAvailable(Network network) {
			                    Log.e("netId",network.toString()+" ");
			                    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
			                        connectivityManager.bindProcessToNetwork(network);
			                    } else {
			                        connectivityManager.setProcessDefaultNetwork(network);
			                    }
			                    Toast.makeText(MainActivity.this, "切换4G成功", 1000).show();
			                    connectivityManager.unregisterNetworkCallback(this);
			                }
			            });
			        }
				 catch(Exception e)
				 {
					 
				 }
				 }
			}
		});
        findViewById(R.id.change_wifi_btn).setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				 if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
			            builder = new NetworkRequest.Builder();
			            builder.addCapability(NetworkCapabilities.NET_CAPABILITY_INTERNET);
			            builder.addTransportType(NetworkCapabilities.TRANSPORT_WIFI);
			            connectivityManager.requestNetwork(builder.build(), new ConnectivityManager.NetworkCallback() {
			                @Override
			                public void onAvailable(Network network) {
			                    Log.e("netId",network.toString()+" ");
			                    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
			                        connectivityManager.bindProcessToNetwork(network);
			                    } else {
			                        connectivityManager.setProcessDefaultNetwork(network);
			                    }
			                    Toast.makeText(MainActivity.this, "切换wifi成功", 1000).show();
			                    connectivityManager.unregisterNetworkCallback(this);
			                }
			            });
			        }
			}
		});
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }
    
}
